
////////////////////////////////////////////////////////////////////////////////
//
//          FREQUENCIMETRO_CW_GEN
//
//
//    AUTOR: CLAUDIO LRIOS            15-01-2014
//    ALTERAO: 08/07/2016 - USO DA BIBLIOTECA LCD_GEN_16X2.C
//    (PERMITE MUDANAS DE PINOS NO MICROCONTROLADOR PARA USO DO LCD)
//    
//    USO JUNTO A EQUIPAMENTOS DE RADIAMADOR, PARA INDICAO DE FREQUENCIA
//    
////////////////////////////////////////////////////////////////////////////////


#include <16F628a.h>
#fuses HS,NOWDT,NOLVP
#use delay(clock=20000000)    //tempo por instruo=0.2us
#bit t1_ov=0x0C.0


//==============================================================================
//ESCOLHA AQUI O VALOR DA FREQUENCIA INTERMEDIARIA (NO USE PONTOS OU VIRGULA):

//int32 const valor_FI = 8988300; //FI  Altere conforme a freq. intermediaria
//int32 const valor_FI = 8989000; //FI  Altere conforme a freq. intermediaria
//int32 const valor_FI = 455000; //FI  Altere conforme a freq. intermediaria
//==============================================================================
//ESCOLHA A AO: SE DEVER SOMAR OU SUBTRAIR (EM 'HZ')
//OBS.CASO NO NECESSITE SOMAR OU SUBTRAIR, APENAS LER A FREQUENCIA REAL, ENTO
// COMENTE AS 2 LINHAS ABAIXO.

 // #define soma_freq_intermediaria //DESCOMENTE PARA SOMAR VALOR DA FI
 //#define subtrai_freq_intermediaria //DESCOMENTE PARA SUBTRAIR VALOR DA FI

//==============================================================================

//Renomeia pinos p/ o lcd (tem que vir antes da biblioteca LCD_16X2_GEN.C))
#bit   db4       = 0x06.0 //rb0  db4 pino 6
#bit   db5       = 0x06.1 //rb1  db5 pino 7
#bit   db6       = 0x06.2 //rb2  db6 pino 8
#bit   db7       = 0x06.3 //rb0  db7 pino 9
#bit   en        = 0x05.2 //ra2  lcd 'enable' pino 1
#bit   rs        = 0x05.1 //ra1  lcd 'rs'  pino 18
#bit   rw        = 0x06.7 //rb7  lcd  'rw' pino 13
#define use_lcd_pin_rw  //usar pino RW no microcontrolador e no no gnd.
#define lcd_pin_setup  //avisa compilador para mudar o pinos conforme acima.
//=============================================================================

#include <LCD_GEN_16x2.C> //biblioteca genrica para LCD 16x2



//macros
#define  linha1      lcd_gotoxy( 1, 1);     //vai para linha 1
#define  linha2      lcd_gotoxy( 1, 2);     //vai para linha 2
#define  limpa_lcd   lcd_send_byte(0,1);  //limpa tela do lcd



void printf_res(int32 valor);//prottipo

//==============================================================================
//        PROGRAMA PRINCIPAL
//==============================================================================

void main() {
   int ciclo8, ciclo;
   int32 freq;
   long freqc_high;
   long freqc_low;
   setup_comparator(NC_NC_NC_NC);
   port_b_pullups(FALSE);
   lcd_init();//inicializao do lcd
   linha1;//linha 1 do lcd
   printf(lcd_putc," \fFrequencimetro\nLarios.Tecnol.ws");//mostra o nome
   delay_ms(1000);//tempo de apresentao


   for(;;) {
      ciclo8=0;
      ciclo=0;
      freqc_high=0;
      t1_ov=0;
      set_timer1(0);
      setup_timer_1(T1_EXTERNAL|T1_DIV_BY_1);

//aguarda um segundo para a amostragem
      while (ciclo!=0xFF) { //v=3, f=4 ciclos
       ciclo8=0; //1 ciclos
       //inicio do loop interno
       while (ciclo8!=0xFF) { //v=3, f=4
         if (t1_ov)//v=2,f=3   ciclos
            {t1_ov=0;freqc_high++;}//6 ciclos
         else
            {delay_cycles(5);}
         delay_cycles(62); //x
         ciclo8++; //1
 //2 ciclos para pular para o alto
 //fim do loop interno
 //total do ciclo interno=((3+8+x+1+2)*255 + 4)*255
 //se x=62.87781 ento o loop interno gasta  5mil instrues
 //se x=62 ento o loop interno gasta  4942920, temos que completar 57080 ciclos
  }
 delay_cycles(216);		//y
 ciclo++;		 	//1 ciclo
 //2 ciclos para pular para o alto
 //para finalizar=(3+1+y+1+2)*255+4=57080
 //y=(57080-4)/255)-(3+1+0+0+1+2)
 //se y=216.827450980392156862745098039216 ento o ciclo de sada  57080
 //se y=216 ento o ciclo de sada necessitar mais 211 ciclos.  z=211
}
      delay_cycles(211);	//
//fim do delay de 1 segundo para amostragem

      setup_timer_1(T1_DISABLED);	//desliga timer1
      if (t1_ov)				//verifica por um ultimo overflow do timer 1
          freqc_high++;
      freqc_low=get_timer1();		//pega o valor do timer 1 como o lsb.
      freq=make32(freqc_high,freqc_low) ;//usamos a funo de unio(lsb and msb)
      #ifdef  soma_freq_intermediaria
      if(freq>=valor_FI) freq+= valor_FI;
      else  freq=0;
      #endif
      #ifdef  subtrai_freq_intermediaria
      if(valor_FI<=freq) freq-= valor_FI;
      else   freq=0;
      #endif

      printf(lcd_putc," \f  Frequencia : \n  ");//limpa e mostra 'frequencia:'
      printf_res(freq); // mostra resultado da medio
      printf(lcd_putc," Hz");// mostra  sufixo 'hz'

   }
}
//==============================================================================
//        MOSTA RESULTADO NO LCD
//==============================================================================
void  printf_res(int32 valor){
   short zero_esq=false;
   int digito,a,b=0;
   int32 div = 10000000;

   if (valor){
      for(a=0; a<8;++a){
         digito=valor/div;
         if(digito) zero_esq=true;
         valor-=digito*div;
         div/=10;
         if (zero_esq){
            lcd_gotoxy( a+3+b, 2);
            lcd_putc(digito + '0');
            if((a==1)||(a==4)) {lcd_putc('.'); ++b; }
         }
      }
   }
   else {
      lcd_gotoxy( 10, 2);//'0' na pos 12
      lcd_putc('0');

   }
}
//==============================================================================
//                            FIM DO PROGRAMA
//==============================================================================


